--[[
Funkcje do obsugi bramek EryOmnix v2 
(C)2003 hao | stamina 
http://www.konnekt.info 

Wszelkie prawa zastrzeone. Wykorzystywanie fragmentw lub caoci kodu w 
jakichkolwiek celach innych ni przesyanie wiadomoci przy pomocy wtyczki 
SMS-Konnekt bez zgody autora ZABRONIONE!
--]] 

include("const.lua");

eoType = ""; -- Typ bramki - "O" Omnix , "OP" Omnix Podst. , "P" Patna
hConnect = 0;
hSession = 0;
verbose = 1;

-- Przygotowanie danych
function eoPrepare(SMS)
  if eoType=="O" then
    SMS.to = preg_matchReturn("/\\d{9}$/" , SMS.to);
  else  
    SMS.to = preg_matchReturn("/\\d{9,}/" , SMS.to);
  end;   
  return SMS;
end;


function eoConnect()
   setInfo("cz..."); 
   hSession = InternetOpen("Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Q312461; MyIE2; .NET CLR 1.0.3705)"); 
   hConnect = InternetConnect(hSession, "www.eraomnix.pl", 80, "", "");
	 if hSession==0 or hConnect==0 then setError("Problem z nawizaniem poczenia!"); end;
	 return hConnect;
end;

function verbInfo(txt)
   if verbose>0 then setInfo(txt);end;
end; 

function eoTemp(name , txt)
  plik=io.open("temp\\era_".. eoType .."_".. name ..".htm" , "wb"); 
  if (plik) then 
    plik:write(txt); 
    plik:close();
  end;       
end;

-- Wysyanie mesa
function eoSendSMS(SMS)
     if not eoConnect() then return end;
     setInfo("Wysyam");
     extended = true;
  	 if        eoType=="O" then url = "multi";
  	    elseif eoType=="OP"  then url = "free"; extended = false;
  	    elseif eoType=="P"  then url = "super"; end;
     hRequest = HttpOpenRequest(hConnect, "POST", "/sms/do/extern/tinker/" .. url .. "/send" , "" , INTERNET_FLAG_NO_AUTO_REDIRECT);
		 hdr = "Content-Type: application/x-www-form-urlencoded";
     data = "success="..urlEncode("http://konnekt.info/success").."&failure="..urlEncode("http://konnekt.info/failure")
        .. "&login=" .. urlEncode(SMS.Login)
        .. "&password=" .. urlEncode(SMS.Pass)
        .. "&message=" .. urlEncode(SMS.msg)
        .. "&contact="
        .. "&signature=" .. urlEncode(SMS.from);

		 if extended then -- wersja rozszerzona  
       data = data
             .. "&numbers=" .. SMS.to 
			     .. "&message=" .. urlEncode(SMS.msg)
			     .. "&filteredMessage=" .. urlEncode(SMS.msg)
			     .. "&signature=" .. urlEncode(SMS.from)
			     ;
			 if SMS.Break ~= "0" then data = data .. "&smartBreaking=on";end;		 
			 if SMS.EMS ~= "0" then data = data .. "&ems=on";end;		 
			 if SMS.Email ~= "0" then data = data .. "&status=on";end;		 
			 if eoType=="O" and SMS.GateNum == "0" then data = data .. "&asPhone=on";end;
     else
       data = data
             .. "&number=" .. SMS.to
             ; 
		 end;
     verbInfo("Wysyam: "..data);
  	 if not HttpSendRequest(hRequest, hdr, data) then setError("Problem z wysyaniem"); return 0; end;
     verbInfo("Dostaem: "..HttpQueryInfo(hRequest , HTTP_QUERY_RAW_HEADERS_CRLF));	  
     txt = HttpQueryInfo(hRequest , HTTP_QUERY_LOCATION);
		 -- Dla wersji podstawowej trzeba jeszcze wykona preview...
     tab = {}
     verbInfo("Serwer zwrci: "..txt);

     if preg_match("/failure/" , txt) > 0 then
       if preg_match("/[&?]X-ERA-error=(\\d+)/" , txt , tab)>1 then
         err = tonumber(tab[1]);
       else err = 0; end;  
       if (err == 1) then err="awaria systemu"
       elseif (err == 2) then err="uytkownik nieautoryzowany" 
       elseif (err == 3) then err="dostp zablokowany" 
       elseif (err == 5) then err="bd skadni" 
       elseif (err == 7) then err="wyczerpany limit SMS" 
       elseif (err == 8) then err="bdny adres odbiorcy SMS" 
       elseif (err == 9) then err="wiadomo zbyt duga"
       else err = err .. " - Nieznany kod bdu!"; end;
       setError(err);
     elseif preg_match("/success/" , txt) > 0 then
       count = 0;
       cost = 0;
       if extended then
         if preg_match("/[&?]X-ERA-tokens=(\\d+)/" , txt , tab) > 1 then count = tonumber(tab[1]);end;
         if preg_match("/[&?]X-ERA-cost=(\\d+)/" , txt , tab) > 1 then cost = tonumber(tab[1]);end;
         if preg_match("/[&?]X-ERA-universalTokens=(\\d+)/" , txt , tab) > 1 then count = tonumber(tab[1]);end;
         if preg_match("/[&?]X-ERA-costUniversalTokens=(\\d+)/" , txt , tab) > 1 then cost = tonumber(tab[1]);end;
         if preg_match("/[&?]X-ERA-eraTokens=(\\d+)/" , txt , tab) > 1 then count = count + tonumber(tab[1]); setInfo("Pozostao "..tab[1].." bkitnych tokenw"); end;
         if preg_match("/[&?]X-ERA-costEraTokens=(\\d+)/" , txt , tab) > 1 then cost = cost + tonumber(tab[1]); setInfo("Zuye "..tab[1].." bkitnych tokenw"); end;
       else
         if preg_match("/[&?]X-ERA-counter=(\\d+)/" , txt , tab) > 1 then count = tonumber(tab[1]);end;
       end;
       if cost~=0 then setInfo("Ten SMS kosztowa: " .. cost .. "pkt.");end;
       setInfo("Dostpna liczba SMSw: " .. count);
		   setVar("maxSendCount" , tonumber(getVar("sentCount")) + count);
		   refreshStatus();
       setSuccess("SMS zosta wysany");
     else
       setError("Nieznany bd!");
     end
     
end;
