--[[ 
	Skrypt obsugujcy bramk SMS na stronie Miasto Plusa, dla wtyczki SMS.dll do programu Konnekt
	(C) 2004 mls <mls@o2.pl>
	http://mwap.kernel.pl/

	Odpowiedzialno za wykorzystywanie skryptu ponosi uytkownik.

	Wymaga obecnoci pliku const.lua w katalogu ze skryptem!
--]]     

include("const.lua"); 

function mp_send(SMS) 
	--- zmie na 1 by wczy debug
	DEBUG = 0;

	--- ustawienie zmiennych
	SMS.to = preg_matchReturn("/\\d{9}$/" , SMS.to); 
	SMS.msg = hidePL(SMS.msg);

	--- sprawdzenie poprawnoci danych
	if (SMS.mpUser == "" or SMS.mpPass == "") then 
		setError("Musisz poda Login oraz Haso do strony Miasto Plusa!");
		alert("Aby wysa SMSy z bramki SMS Miasto Plusa musisz poda Login i Haso!\nMoesz to zrobi w konfiguracji.");
		return;
	end;
	if (SMS.mpFlash == "1") then SMS.mpFlash = "1"; else SMS.mpFlash = "0"; end;

	--- utworzenie sesji poczenia
	hSession = InternetOpen("Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Konnekt SMS)"); 
	if hSession == 0 then setError("Bd tworzenia poczenia."); return; end;

	--- poczenie ze stron
	setInfo("cz z www.miastoplusa.pl...");
	hConnect = InternetConnect(hSession, "www.miastoplusa.pl", 80, "");
	if hConnect == 0 then setError("Bd czenia ze stron!"); return; end;

	--- pobranie cookies
	setInfo("Podbieram ciasteczka... ;)");
	hRequest = HttpOpenRequest(hConnect, "GET", "/", "");
	HttpSendRequest(hRequest, "", "");
	if (DEBUG) then txt = InternetReadFile(hRequest); plik=io.open("temp\\mp_cookie.txt" , "wt"); if (plik) then plik:write(txt); plik:close(plik); end; end;
	InternetCloseHandle(hRequest);

	--- zalogowanie do serwisu
	setInfo("Logowanie do Miasta Plusa...");
	hRequest = HttpOpenRequest(hConnect, "POST", "/auth/LoginCitizen.do", "http://www.miastoplusa.pl", INTERNET_FLAG_NO_AUTO_REDIRECT);
	if hRequest == 0 then setError("Bd podczas logowania!"); return; end;
	data = "login="..urlEncode(SMS.mpUser).."&password="..urlEncode(SMS.mpPass).."&x=0&y=0";
	if not HttpSendRequest(hRequest, "Content-Type: application/x-www-form-urlencoded", data) then
		err = GetLastError();
		setInfo("Bd: "..err);
		return;
	end;
	txt = InternetReadFile(hRequest);
	if (DEBUG) then plik=io.open("temp\\mp_login.txt" , "wt"); if (plik) then plik:write(txt); plik:close(plik); end; end;
	arrLCode = {};
	if (preg_match("/\[errorsAry\.length\] = \'([^\']+)\';/", txt, arrLCode)) then
		if (arrLCode[1] == "Podaj login!") then setError("Podaj login!"); return; end;
		if (arrLCode[1] == "Podaj haso!") then setError("Podaj haso!"); return; end;
		if (arrLCode[1] == "Podane haso jest nieprawidowe. Uwaga, wielko liter ma znaczenie.") then setError("Podane haso jest nieprawidowe. Wielko liter w hale ma znaczenie!"); return; end;
	end;
	setInfo("Zalogowano.");
	InternetCloseHandle(hRequest);

	--- wysyanie smsa
	setInfo("Wysyanie SMSa...");
	hRequest = HttpOpenRequest(hConnect, "POST", "/sms/SendSMS.do", "");
	text = SMS.msg;
	text = urlEncode(text);
	text = preg_replace("#%20#", "+", text);
	data = "smsType=10&phoneNumber="..SMS.to.."&userId=0&groupId=0&message="..text.."&preview=&notifyCode=0&validity=48&sendDay=-1&sendHour=0&sendMin=0&archiveMessage=0&flashMessage="..SMS.mpFlash.."&targetURL=%2Fsms%2Fsend_sms.jsp";
	HttpSendRequest(hRequest, "Content-Type: application/x-www-form-urlencoded", data) 
	txt = InternetReadFile(hRequest);
	if (DEBUG) then plik=io.open("temp\\mp_send.txt" , "wt"); if (plik) then plik:write(txt); plik:close(plik); end; end;

	--- obsuga wynikw
	tabHead = {};
	tabHead[1] = "Komunikat";
	preg_match("#<font color=.#FFFFFF.><b>([^<]+)<\/b><\/font><\/td>#", txt, tabHead);
	if (tabHead[1] ~= "Komunikat") then
		errCode = 2;
		errTab = {};
		preg_match("#    <td>&nbsp;&nbsp;&nbsp;([^<]+)<\/td>#", txt, errTab);
	else
		errCode = 0;
	end;
	arrSMS = {};
	arrSMS[1] = "???";
	preg_match("#<b>SMS\-y wysane w cigu ostatniej godziny: ([0-9]+); ostatnich 24 godzin: ([0-9]+)<\/b>#", txt, arrSMS);
    	if (arrSMS[1] == "???") then
		errCode = 1;
	else
		setInfo("Status wiadomoci:");
		setInfo("SMS-y wysane w cigu ostatniej godziny: "..arrSMS[1]);
		setInfo("SMS-y wysane w cigu ostatnich 24 godzin: "..arrSMS[2]);
	end;
	if (errCode ~= 0) then 
		if (errCode == 2) then setError("Bd: "..iso2cp(errTab[1])); end;
		if (errCode == 1) then setError("Brak informacji wysanych wiadomociach. SMS mg nie zosta wysany!"); end;
	else
		setSuccess("wszystko OK :)");
	end;

	--- zamknicie pocze
	InternetCloseHandle(hRequest); 
	InternetCloseHandle(hConnect); 
	InternetCloseHandle(hSession); 
end; 

function sendSMS(SMS) 
	if (SMS.mpUser == "" or SMS.mpPass == "") then
		setError("Nie podae loginu albo hasa!");
		return;
	end;
	mp_send(SMS); 
end;
